﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetEmployDepartmentDataSet();
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];

            Band childBand = new Band();
            childBand.DataKeyFields = "EmployeeID";
            childBand.DataMember = "Employees";
            childBand.Key = "Employees";
            childBand.AutoGenerateColumns = false;

            WebHierarchicalDataGrid1.Bands.Add(childBand);

            BoundDataField boundField = new BoundDataField(true);
            boundField.Key = "EmployeeID";
            boundField.DataFieldName = "EmployeeID";
            boundField.Header.Text = "Employee ID";

            WebHierarchicalDataGrid1.Bands["Employees"].Columns.Add(boundField);

            boundField = new BoundDataField(true);
            boundField.Key = "Name";
            boundField.DataFieldName = "Name";
            boundField.Header.Text = "Name";

            WebHierarchicalDataGrid1.Bands["Employees"].Columns.Add(boundField);

            boundField = new BoundDataField(true);
            boundField.Key = "Department";
            boundField.DataFieldName = "Department";
            boundField.Header.Text = "Department";

            WebHierarchicalDataGrid1.Bands["Employees"].Columns.Add(boundField);

            WebHierarchicalDataGrid1.DataBind();
        }
        else
        {
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];
        }

    }

    private DataSet GetEmployDepartmentDataSet()
    {
        DataSet ds = new DataSet("EmployeeRecords");

        // Get the tables to use in the DataSet
        DataTable Employees = this.GetEmployees();
        DataTable Departments = this.GetDepartments();

        // Add the tables to the DataSet
        ds.Tables.Add(Departments);
        ds.Tables.Add(Employees);

        // Create the relationship between the tables.
        ds.Relations.Add("DepartmentEmployee", Departments.Columns["DepartmentID"], Employees.Columns["Department"]);
        return ds;
    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Departments");
        dt.Columns.Add("DepartmentID", typeof(int));
        dt.Columns.Add("DepartmentName", typeof(string));

        for (int i = 0; i < 8; i++)
        {
            dt.Rows.Add(new object[] { i, string.Format("Department {0}", i) });
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

        return dt;
    }

    private DataTable GetEmployees()
    {
        return this.GetEmployees(24);
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("Department", typeof(int));


        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), i % 8,});
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }
}